﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using glb;

namespace evc
{
	// エルミート補間(再生用)
	public partial class FpAnimHermite : IFeAnimBase
	{
		// 前のポイントがヘルミートの場合、前のパワーの逆ベクトルに同期させる
		public glbVector2 BefoPower	{ get; set; }
		public glbVector2 Power { get; set; }


		// フレーム(0.0f～1.0f)に対する進行度を取得
		public float GetFramePos( float fAnimFrame, FePointInfo befoInfo, FePointInfo nowInfo )
		{
			float fPointLen = nowInfo.Rate - befoInfo.Rate;
			return (float)seMath.GetHermiteCurvePoint(
						new glbVector2( befoInfo.Rate, befoInfo.Value ),
						this.BefoPower,
						new glbVector2( nowInfo.Rate, nowInfo.Value ),
						this.Power,
						(fAnimFrame - befoInfo.Rate) / fPointLen ).Y;
		}

		// ファイルロード
		public void Load( IseStateInput input )
		{
			this.Power = seIOUtil.ReadVector2( input );
			this.BefoPower = seIOUtil.ReadVector2( input );
		}
	}

}
