﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using glb;


namespace evc
{
	// のこぎり補間(再生用)
	public partial class FpAnimSaw : IFeAnimBase
	{
		public float Num { get; set; }		// のこぎりの歯の数
		public float Scale { get; set; }		// のこぎりの歯の大きさ


		public FpAnimSaw()
		{
			this.Num = 0.0f;
			this.Scale = 0.0f;
		}

		// フレーム(0.0f～1.0f)に対する進行度を取得
		public float GetFramePos( float fAnimFrame, FePointInfo befoInfo, FePointInfo nowInfo )
		{
			float fSawNum = this.Num  * 30.0f;		// のこぎりの歯の数
			float fSawScale = this.Scale * 1.5f;	// のこぎりの歯の高さ

			float fBfoRate = befoInfo.Rate;
			float fRate = (fAnimFrame - fBfoRate) / (nowInfo.Rate - fBfoRate);
	
			// のこぎりの歯の数から今の高さを算出
			float fSaw = fRate * fSawNum;
			// 1.0fで割ったあまりを算出
			fSaw -= (float)((int)fSaw);
			// 歯の高さをかける。
			fSaw *= fSawScale;

			float fBfoValue = befoInfo.Value;
			return ((nowInfo.Value - fBfoValue) * fRate + fBfoValue) + fSaw;
		}

		public void Load(IseStateInput inInput)
		{
			this.Num = inInput.ReadFloat();
			this.Scale = inInput.ReadFloat();
		}
	}
}
