﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace evc
{
	// １ファイル入力管理
	// 非同期でファイルロードされることを前提としています。
	// IsLoadFinishでtrueが返った時のみBufferを使用し、
	// データにアクセスします。
	public interface siFile
	{
		// ファイルロード終了か否か
		// ファイルロードが終了し、siFile.Bufferからデータにアクセス
		// できる状態になったらtrue,それ以外はfalseを返してください。
		// 
		// @retval : true ロード終了  false ロード中or未ロード
		bool IsLoadFinish	{ get; }

		// ロードしたファイルデータを取得
		byte[] Buffer		{ get; }

		// ロード状態更新処理を記述して下さい。
		// siFileがnewされてからIsLoadFinishでtrueが返るまで
		// 毎フレーム呼び出されます。必要ない場合は空にして置いてください。
		void Update();

		// ローダー及びロードした領域の解放
		// ロードをキャンセルする時もこれが呼ばれます。
		void Dispose();
	}
}
