﻿using System;
using System.Collections.Generic;
using System.Text;

namespace evc
{
	// 色加算タイプ
	public enum BlendType
	{
		NORMAL,		// 通常ブレンド
		ADD,		// 色加算
		XOR,		// 反転ブレンド
		NON			// ブレンドなし
	}

	// 重ねタイプ
	public enum DoublyType
	{
		Normal,			// 通常
		Mask,			// マスクイメージ
		MaskReflection,	// マスク適応イメージ
	}


	// 属性変更管理
	public interface siMaterial
	{
		// マスクα値の取得・設定
		// マスクは(255-この値)以上のアルファを持つピクセルが有効になります。
		int MaskAlpha			{ get; set; }

		// 重ねタイプを取得・設定
		DoublyType DoublyType	{ get; set; }

		// ブレンドタイプの取得・設定
		BlendType BlendType		{ get; set; }

		// 状態を反映
		void Apply();
	}
}
