using System;
using System.Collections.Generic;
using System.Text;
using glb;


namespace evc
{
	// 2DxNgZT|[g

	public class seMath
	{
		// SAXP[A]Aʒu2Dp}gNX𐶐
		internal static void Transformation2D(  IGLMatrix mRet, glbVector2 vCenter, glbVector2 vScale, float fRot, glbVector2 vTranslation )
		{
			seMatrixWork.Instance.UseMatrixWork( delegate( IUseWorkMatrix mw )
			{
				IGLMatrix mp = mw.GetMatrix();
				IGLMatrix ms = mw.GetMatrix();
				IGLMatrix mc = mw.GetMatrix();
				IGLMatrix mci = mw.GetMatrix();
				IGLMatrix mr = mw.GetMatrix();

				mp.SetPos( vTranslation );
				ms.SetScale( vScale );
				mr.SetRotZ( fRot );
				mc.SetPos( vCenter );
				mci.Copy( mc );
				mci.Invert();

				// o͗p
				mRet.Copy( mp );
				mRet.Mul( mc );
				mRet.Mul( mr );
				mRet.Mul( ms );
				mRet.Mul( mci );
			});
		}

		// G~[g
		public static glbVector2 GetHermiteCurvePoint( glbVector2 sPos1, glbVector2 sVec1,	
													   glbVector2 sPos2, glbVector2 sVec2,
													   float fRate )
		{
			float r2 = fRate * fRate;
			float ua = (fRate + fRate - 3) * r2;

			// xIɑ̗pB(͈󂳂Ȃ:C++ł͂H)
#if false
			float fV1 = (fRate - 1) * r2;
			float fP0 = ua + 1;
			float fV0 = fV1 - r2 + fRate;
			float fP1 = -ua;
			return new glbVector2( sPos1.X * fP0 + sVec1.X * fV0 + sPos2.X * fP1 + sVec2.X * fV1,
								   sPos1.Y * fP0 + sVec1.Y * fV0 + sPos2.Y * fP1 + sVec2.Y * fV1 );
#else
			float fV1 = (fRate - 1) * r2;
			sPos1.Scale( ua + 1 );
			sVec1.Scale( fV1 - r2 + fRate );
			sPos2.Scale( -ua );
			sVec2.Scale( fV1 );
			
			sPos1.Add( sVec1 );
			sPos1.Add( sVec2 );
			sPos1.Add( sPos2 );
			return sPos1;
#endif
		}

		// G~[g(p[Wt)
		public static glbVector2 GetHermiteCurvePoint( glbVector2 sPos1, glbVector2 sVec1,	
													   glbVector2 sPos2, glbVector2 sVec2,
													   float fRate,
														float fPower)
		{
			float r2 = fRate * fRate;
			float ua = (fRate + fRate - 3) * r2;

			float fV1 = (fRate - 1) * r2;
			sPos1.Scale( ua + 1 );
			sVec1.Scale( (fV1 - r2 + fRate) * fPower);
			sPos2.Scale( -ua );
			sVec2.Scale( fV1 * fPower );
			
			sPos1.Add( sVec1 );
			sPos1.Add( sVec2 );
			sPos1.Add( sPos2 );
			return sPos1;
		}


		// O_xWFȐŕ
		public static glbVector2 GetBezierPoint( glbVector2 p1, glbVector2 p2, glbVector2 p3, float fRate)
		{
			glbVector2 v1 = p2;
			v1.Sub(p1);
			v1.Scale(fRate);
			v1.Add(p1);

			glbVector2 v2 = p3;
			v2.Sub(p2);
			v2.Scale(fRate);
			v2.Add(p2);

			glbVector2 v = v2;
			v.Sub(v1);
			v.Scale(fRate);
			v.Add(v1);

			return v;
		}



		// Q_ΊpƂ钷`mڐGĂ邩
		// ׁ̈AőEŏ`FbN͏ȂB
		// ̈IsHitPolypprivate\bhƂB
		// @retvalue true:qbg@false:qbgȂ
		static private bool IsHitRectangle( glbVector2 aMin, glbVector2 aMax,
											glbVector2 bMin, glbVector2 bMax )
		{
			if ( aMin.X > bMax.X ) return false;
			if ( aMax.X < bMin.X ) return false;
			if ( aMin.Y > bMax.Y ) return false;
			if ( aMax.Y < bMin.Y ) return false;
			return true;
		}
		

		// 2_Ԃ̋߂
		internal static double GetDistance ( glbVector2 p1, glbVector2 p2 )
		{
			p1.Sub( p2 );
			p1.Mul( p1 );
			return Math.Sqrt( p1.X + p1.Y );
		}

		/**
		 * xNg烉WA擾
		 */
		static public float GetRot( glbVector2 startPos, glbVector2 endPos )
		{
			endPos.Sub(startPos);
			return (float)Math.Atan2( endPos.Y, endPos.X );
		}
 

		/**
		 * n_AI_Ԓɑ΂ĔCӂ̓_̉Eɂ邩Aɂ邩
		 * @param sStartPos		: n_
		 * @param sEndPos		: I_
		 * @param sCheckPos		: Cӂ̓_
		 * @retval true E@false 
		 */
		internal static bool CheckSide( glbVector2 sp, glbVector2 ep, glbVector2 checkPos )
		{
			return ( ep.X - sp.X ) * ( checkPos.Y - sp.Y )
				 - ( checkPos.X - sp.X ) * ( ep.Y - sp.Y ) >= 0.0f ? false : true;
		}


		/**
		 * |CgCӂ̋`ɂ邩
		 * `̓_͓ʌ^łKv܂B܂A|Cg̕т
		 * vi܂͔vjłKv܂B
		 */
		internal static bool IsInRect ( glbVector2[] points, glbVector2 pos )
		{
			int iPointNum = points.Length;
			// |CgQȉȂ疳
			if (iPointNum < 3) return false;

			// Ō̓_n_܂ł̍E
			bool bSide = seMath.CheckSide( points[ iPointNum - 1 ], points[ 0 ], pos );

			// SĂ̔肪ȂtrueȊOfalse
			for (int i = 0; i < (iPointNum - 1); i++)
			{
				if (bSide != seMath.CheckSide( points[ i ], points[ i + 1 ], pos ))
					return false;
			}
			return true;
		}

		// Cӂ̓_}gNXϊ`ɂ邩ۂ
		internal static bool IsInRect( glbVector2 size, IGLMatrix mParent, glbVector2 pos )
		{
			bool bHit = false;
			
			seMatrixWork.Instance.UseMatrixWork( delegate( IUseWorkMatrix gw )
			{
				IGLMatrix m = gw.GetMatrix();
				m.Copy( mParent );
				m.Invert();
				pos = m.TransformCoordinate( pos );

				// Size}CiX̏ꍇ͒`ЂԂĂƂ݂Ȃ
				// B
				if (pos.X < Math.Min(size.X, 0.0f)) return;
				if (pos.X > Math.Max(size.X, 0.0f)) return;
				if (pos.Y < Math.Min(size.Y, 0.0f)) return;
				if (pos.Y > Math.Max(size.Y, 0.0f)) return;

				// qbg
				bHit = true;
			});
		
			return bHit;
		}



		// Q̐邩
		internal static bool IsCrossLine( glbVector2 vA1, glbVector2 vA2,
@@@@@@@@@@					   glbVector2 vB1, glbVector2 vB2 )
		{
			// _̂Ƃ͌ĂȂƂ
			// ɒ[ɋ߂ꍇŕ\
			if ( seMath.GetDistance( vA1, vA2 ) < 0.0001f ) return false;
			if ( seMath.GetDistance( vB1, vB2 ) < 0.0001f ) return false;

			glbVector2 vA = new glbVector2( vA2.X - vA1.X, vA2.Y - vA1.Y );
			glbVector2 vB = new glbVector2( vB2.X - vB1.X, vB2.Y - vB1.Y );

			// Oς̒
			float fDeno = (float)(vA.X * vB.Y - vA.Y * vB.X);
			// sȂƂ͌ĂȂƂɂ
			// floaẗׁAȂsɋ߂ꍇƂB
//			if (fDeno == 0.0f) return false;
			if (Math.Abs(fDeno) < 0.0001f) return false;

			glbVector2 v1 = new glbVector2( vA1.X - vB1.X, vA1.Y - vB1.Y );
			
			float t = (float)(v1.Y * vB.X - v1.X * vB.Y) / fDeno;
			if ( t < 0.0f || t > 1.0f ) return false;
			float s = (float)(v1.Y * vA.X - v1.X * vA.Y) / fDeno;
			if ( s < 0.0f || s > 1.0f )	return false;

			return true;
		}
		


		// z̍Ō[0]Ԗڂ͌qĂ`ƂB
		// @retval true:()Ă false:()ĂȂ
		internal static bool IsHitPoly( glbVector2[] aList, glbVector2[] bList )
		{
			if ( aList == null ) return false;
			if ( bList == null ) return false;

			if ( aList.Length <= 0 ) return false;
			if ( bList.Length <= 0 ) return false;

			glbVector2 aMin = aList[ 0 ];
			glbVector2 aMax = aList[ 0 ];
			glbVector2 bMin = bList[ 0 ];
			glbVector2 bMax = bList[ 0 ];
			
			// Wϊ
			for (int i = 1; i < aList.Length; i++)
			{
				// ŏEő咸_쐬
				aMin.X = Math.Min( aList[ i ].X, aMin.X );
				aMin.Y = Math.Min( aList[ i ].Y, aMin.Y );
				aMax.X = Math.Max( aList[ i ].X, aMax.X );
				aMax.Y = Math.Max( aList[ i ].Y, aMax.Y );
			}

			for (int i = 1; i < bList.Length; i++)
			{
				bMin.X = Math.Min( bList[ i ].X, bMin.X );
				bMin.Y = Math.Min( bList[ i ].Y, bMin.Y );
				bMax.X = Math.Max( bList[ i ].X, bMax.X );
				bMax.Y = Math.Max( bList[ i ].Y, bMax.Y );
			}

			// oEfBO{bNX`FbN
			if ( !seMath.IsHitRectangle( aMin, aMax, bMin, bMax ) )
				return false;


			// ӓm̌`FbN
			glbVector2 vBfoAPos = aList[ aList.Length - 1 ];
			foreach (glbVector2 sAVector in aList)
			{
				glbVector2 vBfoBPos = bList[ bList.Length - 1 ];
				foreach (glbVector2 sBVector in bList )
				{
					// mȂ
					if ( seMath.IsCrossLine( vBfoAPos, sAVector, vBfoBPos, sBVector ))
						return true;
					
					vBfoBPos = sBVector;
				}
				vBfoAPos = sAVector;
			}

			// ǂ炩̋`ЕɊSɓĂ܂Ă邩`FbN
			// ӂ͌ȂĂ_`ɂꍇB
			foreach (glbVector2 sBVector in bList )
			{
				if ( seMath.IsInRect( aList, sBVector ) ) return true;
			}

			foreach (glbVector2 sAVector in aList )
			{
				if ( seMath.IsInRect( bList, sAVector ) ) return true;
			}

			// qbgĂȂB
			return false;
		}


	}
}
