﻿using System;
using System.Collections.Generic;
using System.Text;

namespace evc
{

	// サブルーチン呼び出し
	public partial class evCmdFlowCall : evCmdHeader
	{
		public evCallInfo CallInfo{ get; set; }


		// コンストラクタ
		public evCmdFlowCall() : base()
		{
		}
		// コンストラクタ(クローン用)
		public evCmdFlowCall( evCmdFlowCall mst ) : base( mst )
		{
			this.CallInfo = mst.CallInfo;
		}


		// サブルーチン実行
		public override bool DoFunc(IevCmdUI inCmdUI)
		{
			// 無効の場合はなにもしない
			if ( !this.Enable ) return true;
			// 無いときは何もしない。
			if ( this.CallInfo == null ) return true;
			return this.CallInfo.FlowIf.DoFunc( inCmdUI );
		}

		public override void Load(IseStateInput inReader, IevCmdUI inCmdUI)
		{
			int iID = inReader.ReadShort();
			this.CallInfo = inCmdUI.CallManager.Find( iID );
		}

		// クローン
		public override evCmdHeader Clone()
		{
			return new evCmdFlowCall( this );
		}
	}


	// サブルーチン管理
	public partial class evCallInfo
	{
		public evCmdFlowIf FlowIf { get; private set; }

		public evCallInfo()
		{
			this.FlowIf = new evCmdFlowIf();
		}
	}


	// サブルーチンリスト
	public partial class evCmdFlowCallManager : seIDManager<evCallInfo>
	{
		public void Load( IseStateInput inReader, IevCmdUI inCmdUI)
		{
			this.Clear();

			int iCount = inReader.ReadShort();
			seDefine.DebugTrace( "Call Count", iCount );
			for (int i = 0; i < iCount; i++)
			{
				int iID = (int)inReader.ReadShort();
				seDefine.DebugTrace( "Call ID", iID );

				evCallInfo inCallInfo = new evCallInfo();
//				inCallInfo.Name = inReader.ReadString();
				inCallInfo.FlowIf.Load( inReader, inCmdUI );
				this.Add( iID, inCallInfo );
			}
		}
	}

}
