﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.Diagnostics;

namespace evc
{
	
	// 条件イベント
	public enum evCond
	{
		Non = 0,					// なし
		// 以下、イベント起動条件
		InTopRect,			// 最前面でヒットしたか否か
		InRect,				// ポインタが矩形内に入った
		OutRect,			// ポインタが矩形外に出た
		HitRect,			// 矩形同士が接触(引数に矩形を特定するもの。）
		InRectPoint,		// 特定の座標に入ったら
		OutRectPoint,		// 特定の座標から出たら
		IsState,			// 特定の座標から出たら
		IsNotState,			// 特定の座標から出たら

		ComparisonValue,	// 比較(直値、エレメントステータス、キーステータス、数値変数、ユーザーコール)

		IsPush,				// ボタンが押されたなら
		IsFirstPush,		// ボタンが初めて押されたなら
		IsPop,				// ボタンが離されているなら
		IsStartAnim,		// アニメーションが開始するなら
		MovePoint,			// マウスが移動したなら

		// 特殊
		Comment,			// コメント
	};
	

	// 以下、実行イベント
	public enum evEvent
	{
		AnimPlay,		// アニメーション再生
		AnimPause,		// アニメーション一時停止
		AnimContinue,	// アニメーション再開
		AnimJump,		// アニメーションフレーム移動

		SceneAnim,		// シーンアニメーション呼び出し(シーンエレメントの場合のみ)

		InputPause,		// 入力一時停止
		InputContinue,	// 入力再開
		SetStatus,		// ステータス設定
		RemoveStatus,	// ステータス削除
		ClearStatus,	// ステータスクリア
		
		OperatorValue,	// 演算(直値、エレメントステータス、キーステータス、数値変数へ値の授受)

		// デバッグ関係
		DebugString,	// デバッグ表示
		DbWriteNum,		// 変数出力

		// 特殊
		Comment,			// コメント
	}

}
