﻿using System;
using System.Collections.Generic;
#if SL_PROC
using sl;
#endif


namespace evc
{
	/**
	 * １アニメーション管理クラス
	 */
	public partial class seElemAnim
	{
		// DoAll時emElemStateの順で呼び出されるようにSortedDictionaryで定義
		private SortedDictionary<emElemState, seStateKeyManager> dicElemState;

		// 全てのアニメーションに対して処理を実行
		public void DoAll(Action<seStateKeyManager> func)
		{
			if (func == null) return;
			foreach (seStateKeyManager keyManager in this.dicElemState.Values)
			{
				func(keyManager);
			}
		}

		// コンストラクタ
		public seElemAnim ()
		{
			this.dicElemState = new SortedDictionary<emElemState, seStateKeyManager>();
		}

		// 入力
		public void Load( IseStateInput input, seSceneManager scene )
		{
			int iCount = (int)input.ReadShort();
			seDefine.DebugTrace( "StateCount", iCount );
			for (int i = 0; i < iCount; i++)
			{
				emElemState eStateType = input.ReadEnum<emElemState>();
				seStateKeyManager keyManager = new seStateKeyManager( eStateType );
				keyManager.Load( input, scene );
				this.dicElemState[ eStateType ] = keyManager;
			}
		}

	}
}
