﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Diagnostics;
using glb;


namespace evc
{
	// アニメーションキー管理
	public partial class seStateKeyManager
	{
		private const int InvalidKey = -1;

		private List<seStateKeyInfo> _liKeyList = new List<seStateKeyInfo>();
		public ReadOnlyCollection<seStateKeyInfo> Keys { get{ return this._liKeyList.AsReadOnly(); } }

		// データタイプを取得
		public emElemState StateType { get; private set; }

		// コンストラクタ
		internal seStateKeyManager( emElemState eStateType )
		{
			this.StateType = eStateType;
		}

		// キーフレームの削除
		public void Clear()
		{
			this._liKeyList.Clear();
		}

		// 入力
		public void Load( IseStateInput input, seSceneManager scene )
		{
			this.StateType = input.ReadEnum<emElemState>();
			int iCount = (int)input.ReadShort();
			seDefine.DebugTrace( "KeyCount", iCount );
			for (int i = 0; i < iCount; i++)
			{
				seStateKeyInfo key = new seStateKeyInfo();
				int iKeyID = key.Load( input );
				this._liKeyList.Add( key );

				// 有効なキーの場合は登録
				if ( iKeyID != seKeyControlManager.InvalidID )
				{
					scene.KeyControlManager.Add( iKeyID, key );
				}
			}
		}
	}
}
