﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace evc
{
	// キーフレーム用ジャンプスタック
	internal class seStateKeyJumpStack
	{
		public seStateKeyInfo	Key = null;
		public int				iLoopNum = 0;

		// コンストラクタ
		public seStateKeyJumpStack ( seStateKeyInfo inKey, int iLoopNum )
		{
			this.Key = inKey;
			this.iLoopNum = iLoopNum;
		}
	}


	// ジャンプスタック管理(主にループ用)
	internal class seStateJump
	{
		// ジャンプスタックリスト(主にループ用)
		private Stack<seStateKeyJumpStack>	stkJump = new Stack<seStateKeyJumpStack>();

		internal void Clear()
		{
			this.stkJump.Clear();
		}

		// 先頭削除
		internal void Pop()
		{
			this.stkJump.Pop();
		}

		// スタック追加
		// @retval true:追加した　false:追加しなかった(既に登録済み)
		internal bool AddStack( seStateKeyInfo key )
		{
			if ( this.stkJump.Count > 0 )
			{
				// 既に登録されているならループから来たので再登録しない。
				if (this.stkJump.Peek().Key == key) return false;
			}

			this.stkJump.Push( new seStateKeyJumpStack( key, 0 ) );
			return true;
		}
		
		// 先頭のスタックにループ数を追加
		internal seStateKeyJumpStack IncLoopNum()
		{
			if ( this.stkJump.Count <= 0 ) return null;

			seStateKeyJumpStack stack = this.stkJump.Peek();
			stack.iLoopNum ++;
			return stack;
		}

	}
}
