using System;
using System.Collections.Generic;
using System.Text;
using glb;

namespace evc
{
	// gf[^
	internal interface IseFontCharEx
	{
		void UpdateInfo( seFontDrawInfo inDrawInfo );
	}

	// Xs[hύX
	internal class seFontCharExSpeed : IseFontCharEx
	{
		private float fSpeed;
		public seFontCharExSpeed ( float fInSpeed )
		{
			this.fSpeed = fInSpeed;
		}

		// XV
		public void UpdateInfo( seFontDrawInfo inDrawInfo )
		{
			// 1\̂ɂ鎞ԂXV
			inDrawInfo.Speed = inDrawInfo.SceneManager.Option.FrameTime / this.fSpeed;
		}
	}

	// WaitύX
	internal class seFontCharExWait : IseFontCharEx
	{
		private float fWait;
		public seFontCharExWait ( float fInWait )
		{
			this.fWait = fInWait;
		}

		public void UpdateInfo ( seFontDrawInfo inDrawInfo )
		{
			// WaitԂݒ
			inDrawInfo.Wait = inDrawInfo.SceneManager.Option.FrameTime * this.fWait;
		}
	}

	// Aj[VĂяo
	internal class seFontCharExAnim : IseFontCharEx
	{
		private string  strAnim;
		public seFontCharExAnim ( string strInAnim )
		{
			this.strAnim = strInAnim;
		}

		public void UpdateInfo ( seFontDrawInfo inDrawInfo )
		{
			seSceneManager sm = inDrawInfo.SceneManager;
			int iAnimID = sm.AnimManager.FindID( this.strAnim );
			sm.ElemManager.SetAnim( iAnimID );
		}
	}



	// PǗ
	internal class seFontChar
	{
		private List<IseFontCharEx>		inDataEx = null;	// gf[^

		internal siObjectFontChar FontChar	{ get; private set; }	// 擾
		internal glbColor Color				{ get; private set; }	// J[擾

	
		// gf[^o^
		internal void AddData( IseFontCharEx inData )
		{
			if ( this.inDataEx == null )
			{
				this.inDataEx = new List<IseFontCharEx>();
			}
			this.inDataEx.Add( inData );
		}


		// `
		internal void Draw( int iElemID, IGLMatrix mParent, glbColor sBaseColor )
		{
			sBaseColor.Mul( this.Color );
			this.FontChar.Draw( iElemID, mParent, sBaseColor );
		}

		// gf[^ɂԍXV
		internal void UpdateInfo ( seFontDrawInfo inDrawInfo )
		{
			if ( this.inDataEx == null ) return;
			this.inDataEx.ForEach( delegate( IseFontCharEx inExData )
			{
				inExData.UpdateInfo( inDrawInfo );
			});
		}

		// RXgN^
		internal seFontChar (siObjectFontChar inFontChar, glbColor sColor )
		{
			this.FontChar = inFontChar;
			this.Color = sColor;
		}
	}
}
