using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Diagnostics;
using glb;


namespace evc
{
	// Py[W
	// bZ[W
	public class seFontPage
	{
		private List<seFontLine> lisLine = new List<seFontLine>();
		internal ReadOnlyCollection<seFontLine> Lines { get { return this.lisLine.AsReadOnly(); } }

		// `̈TCY擾
		public glbVector2 Size	{ get; private set; }

		// RXgN^
		public seFontPage ()
		{
		}


		// o^֌W

		// Ō̍s擾
		internal seFontLine GetLastLine()
		{
			Debug.Assert( this.lisLine.Count > 0 );
			return this.lisLine[ this.lisLine.Count - 1 ];
		}

		// Vs쐬
		internal void Add( seFontLine inLine )
		{
			this.lisLine.Add( inLine );
		}

		// ڂ̏擾
		internal seFontChar GetCharInfo( int iTextNum )
		{
			foreach (seFontLine line in this.lisLine)
			{
				ReadOnlyCollection<seFontChar> fontChar = line.Chars;

				if ( iTextNum >= fontChar.Count )
				{
					iTextNum -= fontChar.Count;
					continue;
				}
				return fontChar[ iTextNum ];
			}
			return null;
		}





		// f[^NA
		public void Clear()
		{
			this.lisLine.Clear();
		}


		// Py[W̕`TCY擾
		public void UpdateSize()
		{
			// TCYĐݒ
			this.Size = glbVector2.Zero;
			this.lisLine.ForEach( delegate( seFontLine inFontLine )
			{
				// s̃TCYXV
				inFontLine.Apply();

				glbVector2 sLineSize = inFontLine.Size;
				this.Size = new glbVector2( Math.Max( this.Size.X, sLineSize.X ),
											this.Size.Y + sLineSize.Y );
			});
		}


		// Py[W`
		internal void Draw( int iElemID, IGLMatrix mParent, glbColor sColor, int iDrawNum )
		{
			// SC`
			float fHeight = 0.0f;
			int iNowCount = 0;
			foreach (seFontLine inFontLine in this.lisLine)
			{
				if ( !inFontLine.Draw( iElemID, fHeight, mParent, sColor, iDrawNum, ref iNowCount ) ) return;
				fHeight += (float)inFontLine.Size.Y;
			}
		}

	}

}
