﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Drawing;
using System.Diagnostics;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using evc;
using evcIO;

namespace evcPlayer
{
	// Formにドラッグ＆ドロップしたpraファイル内の
	// "default"アニメーションを再生します。
	// MainForm内のReqPlayが再生要求になります。
	// 
	
	
	static class Program
	{
		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main ()
		{
			MainForm inForm = new MainForm();

			// DirectX初期化
			dx_control dx = new dx_control( inForm );

			// 初期化処理
			inForm.Init( dx );


			bool bFirst = true;
			int iBfoTime = 0;


			int iNextFrame = Environment.TickCount;
			int iFrameCount = 0;

			inForm.Show();
			while( inForm.Created )
			{
				// fps
				int iNowFrame = Environment.TickCount;
				if ( iNowFrame >= (iNextFrame + 1000) )
				{
					inForm.Text = "fps " + iFrameCount;
					iFrameCount = 0;
					iNextFrame = iNowFrame;
				}
				
				dx.DoRender( inForm.ARGB, delegate()
				{
					// 前のフレームからの経過時間を算出。
					int iNowTime = Environment.TickCount;
					int iAddTime = iNowTime - iBfoTime;

					if (bFirst)
					{
						iAddTime = 0;
						bFirst = false;
					}
	
					iBfoTime = iNowTime;
		
					// 毎フレーム実行処理
					inForm.Proc( iAddTime );
				});

				iFrameCount ++;
				Application.DoEvents();
			}
			dx.Dispose();
		}

	}

}