using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using glb;
using evc;


namespace evcIO
{
	// J[XvCg`Ǘ
	public class trObjectColorSprite : siObjectColorSprite, IDisposable
	{
		private VertexBuffer		inVartexBuffer;		// _obt@
		private Material			sMaterial;
		private glbVector2			sSize;


		// TCY擾
		public glbVector2 Size		{ get { return this.sSize; } }


		// RXgN^
		public trObjectColorSprite ()
		{
			this.inVartexBuffer = new VertexBuffer(
								typeof(CustomVertex.PositionOnly),
								4,
								trIOManager.Device,
								0,
								CustomVertex.PositionOnly.Format,
								Pool.Managed );
		}

		// TCYXVꂽ
		public void UpdateSize( glbVector2 sSize )
		{
			this.sSize = sSize;
			glbVector2 sPos = new glbVector2();
			CustomVertex.PositionOnly[] ainColorList = new CustomVertex.PositionOnly[ 4 ];
			for ( int i = 0; i < 4; i++ )
			{
				sPos.Set( sSize );
				sPos.Mul( trObjectDefine.avPosBase[ i ] );
				ainColorList[ i ] = new CustomVertex.PositionOnly( sPos.X, sPos.Y, 0.0f );
			}

			this.inVartexBuffer.SetData( ainColorList, 0, LockFlags.None );
#if false
			GraphicsStream stm = this.inVartexBuffer.Lock(0, 0, 0);
			stm.Write(ainColorList);
			this.inVartexBuffer.Unlock();
#endif
		}

		// `v
		public void Draw( int iElemID, IGLMatrix inMatrix, glbColor sColor )
		{
			Device d = trIOManager.Device;
			d.SetTexture( 0, null );
			d.Transform.World = ((trMatrix)inMatrix).Matrix;

			this.sMaterial.Ambient = this.sMaterial.Diffuse = Color.FromArgb( sColor.ARGB );
			d.Material = sMaterial;

			d.SetStreamSource( 0, this.inVartexBuffer, 0 );
			d.VertexFormat = CustomVertex.PositionOnly.Format;
			d.DrawPrimitives( PrimitiveType.TriangleFan, 0, 2 );
		}

		// 
		public void Dispose()
		{
			if ( this.inVartexBuffer != null ) 
			{
				this.inVartexBuffer.Dispose();
				this.inVartexBuffer = null;
			}
		}
	}
}
