using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using glb;
using evc;

namespace evcIO
{
	// PǗ
	public class trObjectFontChar : siObjectFontChar
	{
		private trObjectFont inParent;
		private Texture	inTexture;
		private glbVector2	sUVPos;
		private glbVector2	sSize;
		private glbVector2 sTextureSize;


		// eNX`TCY̎擾Eݒ
		internal glbVector2 TextureSize		{get { return sTextureSize;} set { sTextureSize = value;}}
		// eNX`̎擾Eݒ
		internal Texture Texture			{get { return inTexture; } set { inTexture = value; }}

		// RXgN^
		internal trObjectFontChar ( trObjectFont inParent, Texture inTexture,
									glbVector2 sUVPos, glbVector2 sSize )
		{
			this.inParent = inParent;
			this.inTexture = inTexture;
			this.sUVPos = sUVPos;
			this.sSize = sSize;
		}

		// TCY擾
		public glbVector2 Size	{ get { return this.sSize; } }

		// @param mParent  : }gNX
		public void Draw( int iElemID, IGLMatrix inMatrix, glbColor sColor )
		{
			trObjectTextureSprite inSprite = (trObjectTextureSprite)this.inParent.Sprite;

			// eNX`̐ݒ
			inSprite.UpdateTexture( this.inTexture, this.sTextureSize );
			seMatrixWork.Instance.UseMatrixWork( delegate( IUseWorkMatrix gw )
			{
				IGLMatrix mLocal = gw.GetMatrix();
				IGLMatrix mUV = gw.GetMatrix();
				IGLMatrix mUVSize = gw.GetMatrix();

				mLocal.SetScale( this.sSize );

				mUV.SetUV( this.sUVPos );
				mUVSize.SetScale( this.sSize );
				mLocal.MulR( inMatrix );
				mUV.Mul( mUVSize );

				inSprite.Draw( iElemID, mLocal, sColor, mUV );
			});
		}
	}




	// Ǘ
	public class trObjectFont : siObjectFont
	{
		// tHgC[W쐬ǗNX
		private trObjectFontImageManager inImageManager = null;

		private siObjectTextureSprite	inSprite = null;	// `惏[N
		private Texture[]				ainTextureList = null;


		// `pXvCg擾
		internal siObjectTextureSprite Sprite	{get { return this.inSprite; }}


		// RXgN^
		public trObjectFont ()
		{
			// XvCg
			siIOManager inIOManager = seRootScene.Instance.IOManager;
			this.inSprite = inIOManager.CreateTextureSprite( 0 );
			this.inSprite.UpdateSize( glbVector2.One );
			this.inSprite.UpdateUV( glbVector2.One );
		}

		// tHgX^C쐬
		// @retval ID
		public int CreateFontStyle( string strFontName, float fHeight, seFontStyle Style )
		{
			return this.inImageManager.CreateFontStyle( strFontName, fHeight, Style );
		}

		// o^Jn錾
		public void BeginCharCreating()
		{
			this.inImageManager = new trObjectFontImageManager( this );
		}

		// o^
		public siObjectFontChar CreateChar( int iFontStyle, char cChar )
		{
			return this.inImageManager.CreateChar( iFontStyle, cChar );
		}

		// o^I
		public void EndCharCreating()
		{
			this.inImageManager.Flush();			
			
			// eNX`f[^擾
			this.ainTextureList = this.inImageManager.TextureList;
			this.inImageManager.Dispose();
			this.inImageManager = null;
		}

		// f[^Sč폜
		public void Clear()
		{
			// eNX`폜
			if ( this.ainTextureList != null )
			{
				Array.ForEach( this.ainTextureList, delegate( Texture inTexture )
				{
					inTexture.Dispose();
				});
				this.ainTextureList = null;
			}
		}
		
		// 
		public void Dispose()
		{
			this.Clear();
			this.Sprite.Dispose();
		}
	}

}
