using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using glb;
using evc;

namespace evcIO
{

	// pC[WǗ
	internal class trObjectFontImageManager : IDisposable
	{
		internal const int	ImageSize = 256;	// C[W̃TCY(`)

		trObjectFont		inParent = null;
		glbVector2			sImagePutWorkPos;	// Ōɕ\ʒu()
		float				fLineY;				// ő僉C(ԉ܂łĂf[^)
		Bitmap				inNowBmp = null;
		Graphics			inNowGraphics = null;
		List<Texture>		lisTexture = new List<Texture>();	// gpeNX`Xg
		// f[^Xg
		Dictionary<int,Dictionary<char,trObjectFontChar>> dicCharInfo = new Dictionary<int,Dictionary<char,trObjectFontChar>>();
		// X^CǗNX
		trObjectFontStyleManager	inStyleManager = new trObjectFontStyleManager();


		// eNX`Xg
		internal Texture[] TextureList		{ get { return this.lisTexture.ToArray(); } } 


		// ǗNX쐬
		public siObjectFontChar CreateChar( int iFontStyle, char cChar )
		{
			// ɓo^ĂȂ炻̏Ԃ
			if ( this.dicCharInfo.ContainsKey( iFontStyle ) )
			{
				if ( this.dicCharInfo[ iFontStyle ].ContainsKey( cChar ) )
				{
					return this.dicCharInfo[ iFontStyle ][ cChar ];
				}
			}
			// X^CXgȂꍇ
			else
			{
				this.dicCharInfo[ iFontStyle ] = new Dictionary<char,trObjectFontChar>();
			}
			
			// ̓o^
			trObjectFontChar inCharInfo = this.CreateCharImage( iFontStyle, cChar );
			this.dicCharInfo[ iFontStyle ][ cChar ] = inCharInfo;
			
			return inCharInfo;
		}

		// tHgX^C쐬
		public int CreateFontStyle( string strFontName, float fHeight, seFontStyle Style )
		{
			return this.inStyleManager.Create( strFontName, fHeight, Style );
		}


		// RXgN^
		public trObjectFontImageManager ( trObjectFont inParent )
		{
			this.inParent = inParent;
			// rbg}bv𐶐
			this.inNowBmp = new Bitmap( trObjectFontImageManager.ImageSize, 
										trObjectFontImageManager.ImageSize );
			this.inNowGraphics = Graphics.FromImage( this.inNowBmp );

			this.ClearImage();
			this.sImagePutWorkPos.Set( 0.0f, 0.0f );
		}

		// ̈̉
		public void Dispose()
		{
			this.Clear();
		
			if ( this.inNowGraphics != null )
			{
				this.inNowGraphics.Dispose();
				this.inNowGraphics = null;
			}

			if ( this.inNowBmp != null )
			{
				this.inNowBmp.Dispose();
				this.inNowBmp = null;
			}
		}

		// f[^SăNA
		internal void Clear()
		{
			// eNX`XgNA
			// eNX`̂̍폜͊OɔCB
			this.lisTexture.Clear();

			// tHgX^CNA
			this.inStyleManager.Clear();

			// f[^NA
			this.dicCharInfo.Clear();

			this.ClearImage();
			this.sImagePutWorkPos = glbVector2.Zero;
		}


		// bmpeNX`ɂnullo^ĂLɐݒ
		private void CnvTexture()
		{
			// C[Wꍇ͖
			if ( this.inNowBmp == null ) return;

			// eXg
//			this.inNowBmp.Save( "tes" + this.lisTexture.Count + ".bmp", ImageFormat.Bmp );

			Texture inTexture = new Texture( 
						trIOManager.Device, this.inNowBmp, Usage.None, Pool.Managed );

			this.lisTexture.Add( inTexture );
			
			// SẴLɑ΂Ďs
			glbVector2 glbTexSize = new glbVector2( (float)trObjectFontImageManager.ImageSize,
													(float)trObjectFontImageManager.ImageSize );
			foreach ( Dictionary<char,trObjectFontChar> dicFont in this.dicCharInfo.Values )
			{
				foreach ( trObjectFontChar inCharInfo in dicFont.Values )
				{
					if ( inCharInfo.Texture == null )
					{
						inCharInfo.Texture = inTexture;
						inCharInfo.TextureSize = glbTexSize;
					}
				}
			}
		}

		// bmpC[WNA
		private void ClearImage()
		{
			this.inNowGraphics.Clear( Color.FromArgb( 0 ) );
		}


		// o^̎c̃f[^o
		internal void Flush()
		{
			this.CnvTexture();
			// o͐č쐬
			this.ClearImage();
			this.sImagePutWorkPos.Set( 0.0f, 0.0f );
		}


		// bitmapɃLC[Wl߂
		internal trObjectFontChar CreateCharImage( int iFontStyle, char cChar )
		{
			TextFormatFlags eTextFlgs = TextFormatFlags.NoPadding;
//			TextFormatFlags eTextFlgs = TextFormatFlags.Default;

			trObjectFontStyle inFont = this.inStyleManager.Find( iFontStyle );

			Size sCharSize = TextRenderer.MeasureText( this.inNowGraphics, cChar.ToString(),
											inFont.RegisterFont,
											inNowBmp.Size, eTextFlgs );

			// zuʒu
			if ( (this.sImagePutWorkPos.X + sCharSize.Width) > inNowBmp.Width )
			{
				this.sImagePutWorkPos.Set( 0.0f, this.fLineY );
			}
			// ς܂ŕl߂
			if ( (this.sImagePutWorkPos.Y + sCharSize.Height) > inNowBmp.Height )
			{
				// ܂ł̓o^Uo
				this.Flush();
			}

			TextRenderer.DrawText( this.inNowGraphics, cChar.ToString(),
								inFont.RegisterFont,
								new Point( (int)this.sImagePutWorkPos.X,
										   (int)this.sImagePutWorkPos.Y ),
								Color.White, eTextFlgs );

			// UVW̐ݒ
			glbVector2 sUVPos = this.sImagePutWorkPos;
			sUVPos.Scale( 1.0f / (float)trObjectFontImageManager.ImageSize );
			glbVector2 sSize = new glbVector2( (float)sCharSize.Width, (float)sCharSize.Height );

			// ̑傫擾
			trObjectFontChar inCharInfo = new trObjectFontChar( this.inParent, null, sUVPos, sSize );
			

			this.sImagePutWorkPos.X += sCharSize.Width + 1;

			this.fLineY = Math.Max( this.fLineY,
					this.sImagePutWorkPos.Y + sCharSize.Height );

			return inCharInfo;
		}
	}
}
