using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using glb;
using evc;


namespace evcIO
{
	// tHgX^CǗ
	internal class trObjectFontStyle
	{
		private string		strFontName;
		private float		fHeight;
		private FontStyle	eStyle;
		private Font		inFont = null;
		

		public FontStyle Style		{ get { return eStyle; } }
		// tHg̍擾Eݒ
		public float Height			{ get { return fHeight; } }
		// tHg̎擾Eݒ
		public string FontName		{ get { return strFontName; } }

		internal Font RegisterFont	{ get { return this.inFont; } }


		public bool IsSameData( trObjectFontStyle inStyle )
		{
			if ( this.eStyle != inStyle.Style ) return false;
			if ( this.fHeight != inStyle.Height ) return false;
			if ( !this.strFontName.Equals( inStyle.FontName ) ) return false;

			return true;
		}

		// RXgN^
		public trObjectFontStyle ( string strFontName, float fHeight, FontStyle eStyle )
		{
			this.strFontName = strFontName;
			this.fHeight = fHeight;
			this.eStyle = eStyle;

			this.inFont = new Font( strFontName, fHeight, eStyle );
		}

		internal void Dispose()
		{
			if ( this.inFont != null )
			{
				this.inFont.Dispose();
				this.inFont = null;
			}
		}
		
	}

	// tHgX^CǗ
	internal class trObjectFontStyleManager
	{
		// tHgX^CXg
		List<trObjectFontStyle>	lisStyle = new List<trObjectFontStyle>();

		// X^C
		internal trObjectFontStyle Find( int iIndex )
		{
			int iCount = 0;
			foreach (trObjectFontStyle inStyleData in this.lisStyle)
			{
				if( iCount == iIndex ) return inStyleData;
				iCount ++;
			}
			return null;
		}

		// @retval ID
		public int Create( string strFontName, float fHeight, seFontStyle Style )
		{
			trObjectFontStyle inFontStyle = new trObjectFontStyle( strFontName, fHeight, (FontStyle)Style );

			int iIndex = 0;
			foreach (trObjectFontStyle inStyleData in this.lisStyle)
			{
				if ( inStyleData.IsSameData( inFontStyle ) ) return iIndex;
				iIndex ++;
			}
			
			this.lisStyle.Add( inFontStyle );
			return iIndex;
		}


		internal void Clear()
		{
			// tHgX^C̉
			this.lisStyle.ForEach( delegate( trObjectFontStyle inFontStyle )
			{
				inFontStyle.Dispose();
			});
			this.lisStyle.Clear();
		}

	}

}
