using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Diagnostics;
using System.Runtime.InteropServices;
using glb;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using evc;

namespace evcIO
{
	// eNX`XvCg`Ǘ
	public class trObjectMesh : siObjectMesh
	{
		private Texture _texture = null;	// eNX`
		private Material _material;			// }eA
		private VertexBuffer _vertex;
		private int _vertexCount;
		private IndexBuffer _index;
		private int _primCount;
		private MeshIndex _indexType;

		// _ҏW[N
		private CustomVertex.PositionTextured[] vertexInfo;

		// RXgN^
		public trObjectMesh (MeshIndex indexType, int iVertexCount, int iIndexCount )
		{
			this._indexType = indexType;
			this._vertexCount = iVertexCount;
			this._vertex = new VertexBuffer(
								typeof(CustomVertex.PositionTextured),
								iVertexCount,
								trIOManager.Device,
								0,
								CustomVertex.PositionTextured.Format,
								Pool.Managed );

			this._index = new IndexBuffer(
								trIOManager.Device,
								iIndexCount * sizeof(short),
								Usage.None, 
								Pool.Managed, 
								true ); 
		}



		public void SetPos(int iIndex, glbVector2 pos)
		{
			this.vertexInfo[ iIndex ].X = pos.X;
			this.vertexInfo[ iIndex ].Y = pos.Y;
			this.vertexInfo[ iIndex ].Z = 0.0f;
		}

		public void SetUV(int iIndex, glbVector2 uv)
		{
			this.vertexInfo[ iIndex ].Tu = uv.X;
			this.vertexInfo[ iIndex ].Tv = uv.Y;
		}

		public void BeginEditVertex( int iElemID )
		{
			this.vertexInfo = (CustomVertex.PositionTextured[])this._vertex.Lock( 0, LockFlags.None );
		}

		public void EndEditVertex()
		{
			this._vertex.Unlock();
		}


		// eNX`XVꂽ
		void siObjectMesh.UpdateTexture(siResourceTexture texture )
		{
			this._texture = (texture == null) ?
						null : ((trResourceTexture)texture).Texture;
		}


		public void SetIndex(short[] id )
		{
			switch (this._indexType)
			{
				case MeshIndex.TriangleList:
					this._index.SetData(id, 0, LockFlags.None);
					this._primCount = id.Length / 3;
					break;
				default:
					Debug.Assert( false );
					break;
			}
		}


		// `v
		public void Draw(int iElemID, IGLMatrix m, glbColor sColor, IGLMatrix mUV)
		{
			Device d = trIOManager.Device;
			d.SetTexture( 0, this._texture );
			d.Transform.World = ((trMatrix)m).Matrix;
			// eNX`}gNXݒ
			d.Transform.Texture0 = ((trMatrix)mUV).Matrix;

			this._material.Ambient = 
			this._material.Diffuse = Color.FromArgb( sColor.ARGB );
			d.Material = _material;

			d.SetStreamSource( 0, this._vertex, 0 );
			d.VertexFormat = CustomVertex.PositionTextured.Format;
			d.Indices = this._index;
			d.DrawIndexedPrimitives( PrimitiveType.TriangleList, 0, 0,
						this._vertexCount, 0, this._primCount );
		}

		// 
		public void Dispose()
		{
			this._index.Dispose();
			this._vertex.Dispose();
		}
	}

}
