using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Diagnostics;
using System.Threading;
using Microsoft.DirectX.DirectSound;
using glb;
using evc;

namespace evcIO
{
	// TEhǗ
	public class trObjectSound : siObjectSound , IDisposable
	{
		private const int buffersize = 262144; //256KB

		private WavFormatCtrl		inWavFormatCtrl;
		private Stream				inStream;
		private long				lStreamPos = 0;	// Xg[͕ANZXAʒu͏ɏĂ
		private SecondaryBuffer		inSecBuffer = null;
		private Notify				no = null;
		private Thread				th = null;
		private AutoResetEvent[]	are = null;
		private bool				bStopSound = false;	// ItO
		private byte[]				abSoundBuffer = new byte[ buffersize / 2 ];


		private bool bEnableLoop = false;
		public bool EnableLoop { get { return this.bEnableLoop; } }

		// Đۂ
		private bool bPlay = false;	// ĐtO
		public bool IsPlay {get { return this.bPlay; }}



		public trObjectSound ( siResourceSound inResource )
		{
			trResourceSound inSoundResource = (trResourceSound)inResource;
			this.inWavFormatCtrl = inSoundResource.WavFormat.Clone();
			this.inStream = inSoundResource.Stream;

			BufferDescription desc = new BufferDescription( this.inWavFormatCtrl.Format );
			desc.Flags = BufferDescriptionFlags.CanGetCurrentPosition
					   | BufferDescriptionFlags.ControlPositionNotify
					   | BufferDescriptionFlags.ControlVolume
					   | BufferDescriptionFlags.ControlPan
					   | BufferDescriptionFlags.LocateInSoftware
					   | BufferDescriptionFlags.ControlFrequency;

			desc.BufferBytes = buffersize;
			this.inSecBuffer = new SecondaryBuffer( desc, trIOManager.SoundDevice );


			this.are = new AutoResetEvent[]
			{
				new AutoResetEvent(true),  //Ԓn_ʒmp
				new AutoResetEvent(true),  //ŏIn_ʒmp
			};

			BufferPositionNotify[] asBpn = new BufferPositionNotify[ this.are.Length ];

			asBpn[ 0 ].Offset = buffersize / 2 - 1;
			asBpn[ 0 ].EventNotifyHandle = are[ 0 ].SafeWaitHandle.DangerousGetHandle();
			asBpn[ 1 ].Offset = buffersize - 1;
			asBpn[ 1 ].EventNotifyHandle = are[ 1 ].SafeWaitHandle.DangerousGetHandle();

			this.no = new Notify( this.inSecBuffer );
			this.no.SetNotificationPositions( asBpn );
		}


	
		// pXVꂽ
		public void UpdatePan( int iPan )
		{
			// evc:-1000`1000  DirectX: -10000`10000ɕϊ
			iPan = iPan * 10;
			if ( iPan > 10000 ) iPan = 10000;
			if ( iPan < -10000 ) iPan = -10000;

			this.inSecBuffer.Pan = iPan;
		}
		// {[XVꂽ
		public void UpdateVolume( int iVolume )
		{
			// evc:0`1000  DirectX: -10000`0ɕϊ
			iVolume = iVolume * 10 - 10000;
			if ( iVolume > 0 ) iVolume = 0;
			if ( iVolume < -10000 ) iVolume = -10000;

			this.inSecBuffer.Volume = iVolume;
		}


		// tH[}bgw肵čĐ
		private void PlayLocal ( float fStart, float fPlayTime, bool bEndLimit, bool bLoop )
		{
			// x~߂
			this.Stop();

			this.bEnableLoop = bLoop;
			this.inWavFormatCtrl.Start = fStart;
			this.inWavFormatCtrl.Time = fPlayTime;
			this.inWavFormatCtrl.EndLimit = bEndLimit;
			this.inWavFormatCtrl.SetTime( this.inStream, 0.0f );

			this.lStreamPos = this.inStream.Position;

			this.bPlay = true;
			this.bStopSound = false;
			this.th = new Thread( new ThreadStart( StreamLoad ) );
			this.th.Start();
		}

		// Đv
		public void Play( int iElemID, float fStartTime, bool bLoop )
		{
			this.PlayLocal( fStartTime, 0.0f, false, bLoop );
		}
		public void Play( int iElemID, float fStartTime, float fLength, bool bLoop )
		{
			this.PlayLocal( fStartTime, fLength, true, bLoop );
		}


		// ~v
		public void Stop()
		{
			this.bStopSound = true;
			if ( this.th != null )
			{
				this.th.Join();
				this.th = null;
			}
			this.bPlay = false;
		}

		// fobOp`()
		public void Draw( IGLMatrix m, int iVolume, int iPan ){}
		


		// 
		public void Dispose ()
		{
			if (this.inSecBuffer != null)
			{
				this.inSecBuffer.Stop();
				this.inSecBuffer.Dispose();
			}

			if (this.th != null)
			{
				if ( this.th.ThreadState == System.Threading.ThreadState.Running )
				{
					this.th.Abort();
				}
				this.are[ 2 ].Set();
				this.th.Join();
			}

			Array.ForEach( this.are, delegate( AutoResetEvent inEvent )
			{
				inEvent.Close();
			});
		}

		// [Nobt@Ƀf[^[h
		private int ReadBuffer( int iOffset, int iReadSize )
		{
			// Xg[f[^[h
			this.inStream.Position = this.lStreamPos;

			// NGXgTCYWav̍Ō̃f[^𒴂ĂȂŌ܂łɂB
			if ((this.lStreamPos + iReadSize) > this.inWavFormatCtrl.LastWavePos)
			{
				iReadSize = (int)(this.inWavFormatCtrl.LastWavePos - this.lStreamPos);
			}

			int iRet = this.inStream.Read( this.abSoundBuffer, iOffset, iReadSize );
			this.lStreamPos = this.inStream.Position;

			return iRet;
		}



		// obt@Wavf[^
		// @param iBufferID : obt@hc(0 or 1)
		private bool SetBuffer( int iBufferID )
		{
			// ptO
			bool bContinue = true;

			int iFreeSize = abSoundBuffer.Length;

			// [vĐ̏ꍇ
			if ( this.bEnableLoop )
			{
				while ( iFreeSize > 0 )
				{
					// ǂݍ݃NGXgTCY
					int iOffset = abSoundBuffer.Length - iFreeSize;
		
					// Xg[f[^[h
					int iReadSize = this.ReadBuffer( iOffset, iFreeSize );

					// ǂݍݒɃXg[IȂ
					if (iReadSize < iFreeSize)
					{
						// 擪ɖ߂B
						this.lStreamPos = this.inWavFormatCtrl.WavOffset + this.inWavFormatCtrl.StartPos;
					}
					iFreeSize -= iReadSize;
				}
			}
			// PĐ̏ꍇ
			else
			{
				// Xg[f[^[h
				int iReadSize = this.ReadBuffer( 0, iFreeSize );

				// ]͖̈ɐݒ肵ĂB
				byte bSilent = (this.inWavFormatCtrl.Format.BitsPerSample == (short)16) ?
															(byte)0x00 : (byte)0x80;
				for (int i = iReadSize; i < abSoundBuffer.Length; i++)
				{
					abSoundBuffer[i] = bSilent;
				}

				// P̓f[^Ȃ
				if ( iReadSize == 0 ) bContinue = false;
			}

			int iPosOffset = (buffersize / 2) * iBufferID;
			this.inSecBuffer.Write( iPosOffset, this.abSoundBuffer, LockFlag.None );

			return bContinue;
		}


		private void StreamLoad ()
		{
			// obt@ȂXbh̏I
			if ( this.inSecBuffer == null ) return;

//			Trace.Write( "Start\n" );

			try
			{
				this.are[ 0 ].Reset();
				this.are[ 1 ].Reset();
				this.inSecBuffer.SetCurrentPosition( 0 );

				bool[] abContinue = new bool[] { true, true };
				
				// ŏ̂Pobt@͑S
				abContinue[ 0 ] = this.SetBuffer( 0 );
				abContinue[ 1 ] = this.SetBuffer( 1 );
				
				this.inSecBuffer.Play( 0, BufferPlayFlags.Looping );

				while (true)
				{
					int iEvent = AutoResetEvent.WaitAny( this.are, 50, true );

					// ItOĂȂI
					if ( this.bStopSound ) break;

					// IɏIm
					if ( iEvent == WaitHandle.WaitTimeout) continue;


					switch ( iEvent )
					{
						case 0:
						case 1:
							// tOĂȂI
							if ( !abContinue[ iEvent ^ 1 ] )
							{
								this.bStopSound = true;
								break;
							}
							// ͏Ȃ疳
							abContinue[ iEvent ] = this.SetBuffer( iEvent );
							break;

						// ̒ʒmXbh̃C[vIB
						// [vXg[̏ꍇ͂̏Iɂ͂ȂB
						case 2:
							this.bStopSound = true;
							break;
					}

					// ItOĂȂI
					if ( this.bStopSound ) break;

				}

				this.inSecBuffer.Stop();
				this.bPlay = false;
			}
			// IɔԗO
			catch ( Exception )
			{
				this.inSecBuffer.Stop();
				this.bPlay = false;
			}
		}

	}
}
