using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using glb;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using evc;

namespace evcIO
{

	// eNX`XvCg`Ǘ
	public class trObjectTextureSprite : siObjectTextureSprite , IDisposable
	{
		private VertexBuffer		inVartexBuffer;		// _obt@
		private Material			sMaterial;			// }eA
		private Texture				inTexture = null;	// eNX`
		private glbVector2			sUV;				// UV
		private glbVector2			sSize;				// TCY
		private glbVector2			sTextureSize;		// eNX`TCY
		private bool				bApply = false;		// XVtO
		

		// TCY擾
		public glbVector2 Size		{ get { return this.sSize; } }

		// RXgN^
		public trObjectTextureSprite ()
		{
			this.inVartexBuffer = new VertexBuffer(
								typeof( CustomVertex.PositionTextured) ,
								4,
								trIOManager.Device, 
								0, 
								CustomVertex.PositionTextured.Format, 
								Pool.Managed );
		}

		// eNX`XVꂽ
		// DirectX̃eNX`𒼐ڐݒ肵܂B
		// ̃\bhevcł͂ȂAtrFontImageManagergp܂B
		// \ɂ̃NX𗬗pĂׂłB
		// \Ǝɏꍇ͂̃\bh͕Kv܂B
		public void UpdateTexture( Texture inTexture, glbVector2 sInTextureSize )
		{
			this.inTexture = inTexture;
			this.sTextureSize = sInTextureSize;
//			this.bApply = true;
		}

		// eNX`XVꂽ
		public void UpdateTexture( siResourceTexture inTextureResource )
		{
			if ( inTextureResource == null ) 
			{
				this.inTexture = null;
			}
			else
			{
				this.inTexture = ((trResourceTexture)inTextureResource).Texture;
				this.sTextureSize.Set( inTextureResource.TextureSize.X,
									   inTextureResource.TextureSize.Y );
			}

			// _͘MȂ̂ōXVtO͗ĂȂB
		}

		// TCYXVꂽ
		public void UpdateSize( glbVector2 sSize )
		{
			this.sSize = sSize;
			this.bApply = true;
		}
		// UVXVꂽ
		public void UpdateUV( glbVector2 sUV )
		{
			this.sUV = sUV;
			this.bApply = true;
		}

		// _XV
		private void Update()
		{
			glbVector2 sUVOffset = glbVector2.Zero;

			if ( this.inTexture != null )
			{
				sUVOffset.X = this.sSize.X / this.sTextureSize.X;
				sUVOffset.Y = this.sSize.Y / this.sTextureSize.Y;
			}

			// _ݒ
			glbVector2 sPos = new glbVector2();
			glbVector2 sUV = new glbVector2();
			CustomVertex.PositionTextured[] ainTexList = new CustomVertex.PositionTextured[ 4 ];
			for ( int i = 0; i < 4; i++ )
			{
				sPos.Set( this.sSize );
				sPos.Mul( trObjectDefine.avPosBase[ i ] );
				sUV.Set( sUVOffset );
				sUV.Mul( trObjectDefine.avPosBase[ i ] );
				sUV.Add( this.sUV );
				ainTexList[ i ] = new CustomVertex.PositionTextured(
											sPos.X, sPos.Y, 0.0f, sUV.X, sUV.Y );
			}

			GraphicsStream stm = this.inVartexBuffer.Lock( 0, 0, 0 );
			stm.Write( ainTexList );
			this.inVartexBuffer.Unlock();
		}

		// `v
		private void Draw(int iElemID, IGLMatrix m, glbColor color, Matrix mUV)
		{
			// tOĂΒ_obt@XV
			if ( this.bApply )
			{
				this.Update();
				this.bApply = false;
			}

			Device d = trIOManager.Device;
			d.SetTexture( 0, this.inTexture );
			d.Transform.World = ((trMatrix)m).Matrix;
			d.Transform.Texture0 = mUV;

			this.sMaterial.Ambient = this.sMaterial.Diffuse = Color.FromArgb( color.ARGB );
			d.Material = sMaterial;

			d.SetStreamSource( 0, this.inVartexBuffer, 0 );
			d.VertexFormat = CustomVertex.PositionTextured.Format;
			d.DrawPrimitives( PrimitiveType.TriangleFan, 0, 2 );
		}



		// `v
		public void Draw( int iElemID, IGLMatrix m, glbColor color )
		{
			this.Draw(iElemID, m, color, Matrix.Identity);
		}

		// `v
		public void Draw( int iElemID, IGLMatrix m, glbColor color, IGLMatrix mUV )
		{
			this.Draw(iElemID, m, color, ((trMatrix)mUV).Matrix);
		}
		
		// 
		public void Dispose()
		{
			if ( this.inVartexBuffer != null )
			{
				this.inVartexBuffer.Dispose();
				this.inVartexBuffer = null;
			}
		}
	}
}
