﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace evcIO
{
	// チャンク情報
	internal class ChunkInfo
	{
		public int		iChunkID;
		public int		iChunkSize;					// チャンクサイズ
		public long		lOffset;					// データオフセット
		
		// ファイルストリームからチャンク情報を登録
		// ストリームの位置はデータのところまで移動
		public void Register( BinaryReader inReader )
		{
			this.iChunkID = inReader.ReadInt32();
			this.iChunkSize = inReader.ReadInt32();
			this.lOffset = inReader.BaseStream.Position;
		}

		// 次のチャンクへストリームを移動
		public void NextChunk( BinaryReader inReader )
		{
			inReader.BaseStream.Position = this.lOffset + (long)this.iChunkSize;
		}

		internal const int Fmt = 0x20746d66;	// "fmt "
		internal const int Data = 0x61746164;	// "data"
	}
}
