using System;
using System.Drawing;
using System.IO;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using evc;
using glb;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace evcIO
{
	// eNX`C[WǗ
	
	public class trResourceTexture : siResourceTexture
	{
		// eNX`
		public Texture Texture { get; private set; }

		// eNX`TCY擾
		private glbVector2I sTextureSize;
		public override glbVector2I TextureSize { get { return this.sTextureSize; } }

		// qbgf[^
		private byte[] abHitBuffer;


		// RXgN^
		public trResourceTexture( string strInTextureName ) : base( strInTextureName ){}

		// eNX`
		public override siResourceInitType Init( byte[] abData )
		{
			MemoryStream inStream = new MemoryStream( abData );
			try
			{
				ImageInformation sInfo = TextureLoader.ImageInformationFromStream( inStream );
				inStream.Position = 0;
				this.Texture = TextureLoader.FromStream( trIOManager.Device,
															inStream, 
															sInfo.Width, sInfo.Height,
															0, 
															Usage.None, 
															sInfo.Format, 
															Pool.Managed,
															Filter.None, Filter.None, 0 );

				this.sTextureSize = new glbVector2I( sInfo.Width, sInfo.Height );
				GraphicsStream gs = TextureLoader.SaveToStream( ImageFileFormat.Png, this.Texture );
				Bitmap b = new Bitmap( gs );
				// qbgf[^쐬
				this.CreateHitData( b );
				gs.Dispose();
				b.Dispose();

			}
			// ڃ[hɎsꍇAPxBitmapɕϊĂ݂B
			catch (Exception)
			{
				inStream.Position = 0;
				Bitmap inBmp = new Bitmap( inStream );
				this.Texture = new Texture( trIOManager.Device, inBmp, Usage.None, Pool.Managed );
				this.sTextureSize = new glbVector2I( inBmp.Size.Width, inBmp.Size.Height );
				// qbgf[^쐬
				this.CreateHitData( inBmp );
				inBmp.Dispose();
			}

			return siResourceInitType.Success;
		}


		// rbg}bvqbgf[^쐬
		// rbg}bvC[W烿l݂̂𔲂oĕێ܂B
		private void CreateHitData( Bitmap inBmp )
		{
			// qbgC[WĂ
			BitmapData bmpData = inBmp.LockBits(
							new Rectangle( 0, 0, inBmp.Width, inBmp.Height ),
							ImageLockMode.ReadOnly,
							PixelFormat.Format32bppArgb );

			// At@l݂̂𔲂oăqbgobt@쐬
			this.abHitBuffer = new byte[ this.TextureSize.X * this.TextureSize.Y ];
			byte[] abBuffer = new byte[ bmpData.Stride * inBmp.Height ];
			Marshal.Copy( bmpData.Scan0, abBuffer, 0, abBuffer.Length );

			int iCount = 0;
			for (int y = 0; y < this.TextureSize.Y; y++)
			{
				for (int x = 0; x < this.TextureSize.X; x++)
				{
					this.abHitBuffer[ iCount ] = abBuffer[ (y * bmpData.Stride) + (x * 4) + 3 ];
					iCount ++;
				}
			}

			inBmp.UnlockBits( bmpData );
		}


		// \[X
		public override void Dispose()
		{
			if ( this.Texture != null )
			{
				this.Texture.Dispose();
				this.Texture = null;
			}
		}

		// 蔻
		// 摜(0,0)-(sTextureSize.X,sTextureSize.Y)͈̔͂
		// 1_ɑ΂ăqbgĂ邩ԂĂB
		// {Tvł̓O(̃hbgSɓ)̏ꍇ̓qbgȂƂ܂B
		public override bool IsHit(glbVector2I sPos)
		{
			int iIndex = sPos.X + (this.sTextureSize.X * sPos.Y);
			// EȂqbgȂ
			if ( this.abHitBuffer.Length <= iIndex ) return false;
			return (this.abHitBuffer[ iIndex ] > 0);
		}
	}
}
