using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using System.Diagnostics;
using evc;
using glb;
using Microsoft.DirectX;
using DxSound = Microsoft.DirectX.DirectSound;
using Dx3D = Microsoft.DirectX.Direct3D;

namespace evcIO
{
	public class trIOManager : siIOManager
	{
		private bool _bUseMask;

		// foCX擾
		private static Dx3D.Device inDevice = null;
		internal static Dx3D.Device Device { get { return trIOManager.inDevice; } }

		// TEhfoCX̎擾
		private static DxSound.Device inSoundDevice = null;
		internal static DxSound.Device SoundDevice { get { return trIOManager.inSoundDevice; } }

		// RXgN^
		internal trIOManager ( Dx3D.Device device, Control inTarget )
		{
			this._bUseMask = false;
			trIOManager.inDevice = device;
			trIOManager.inSoundDevice = new DxSound.Device();

            //x̐ݒ
            trIOManager.inSoundDevice.SetCooperativeLevel( inTarget, DxSound.CooperativeLevel.Priority );
		}


		// }gNX쐬
		public IGLMatrix CreateMatrix()	
		{
			return new trMatrix();
		}

		// eNX`\[X쐬ɌĂяo܂B
		// @parama strName:̓t@CpX
		// @retval null:s  !null:
		public siResourceTexture CraeteTextureResource(
				seSceneManager inSceneManager, string strInTextureName, glbVector2I sTexSize )
		{
			return new trResourceTexture( strInTextureName );
		}

		// TEh̃\[X쐬ɌĂяo܂B
		// @parama strName:̓t@CpX
		// @retval null:s  !null:
		public siResourceSound CraeteSoundResource( seSceneManager inSceneManager, string strInSoundName )
		{
			return new trResourceSound( strInSoundName );
		}



		// J[XvCg̍쐬vꂽɌĂяo܂B
		public siObjectColorSprite CreateColorSprite( int iID )
		{
			return new trObjectColorSprite();
		}

		// eNX`XvCg̍쐬vꂽɌĂяo܂B
		public siObjectTextureSprite CreateTextureSprite( int iID )
		{
			return new trObjectTextureSprite();
		}

		// TEh̍쐬vꂽɌĂяo܂B
		public siObjectSound CreateSound( int iID, siResourceSound inResource )
		{
			return new trObjectSound( inResource );
		}


		// `Ǘ쐬
		public siObjectFont CreateFont( int iID )
		{
			return new trObjectFont();
		}

		// bV`Ǘ쐬
		public siObjectMesh CreateMesh(int iID, MeshIndex indexType, int iVertexCount, int iIndexCount)
		{
			return new trObjectMesh( indexType, iVertexCount, iIndexCount );
		}


		#region }XN֌W

		// V}XNo^
		// }XN`悪Ă΂钼OɐV}XN̑S̗̈\}gNXƂ
		// ̃\bhĂ΂܂B
		// RegisterMask͐V}XNݒ肷xɌĂ΂܂B
		public void RegisterMask ( IGLMatrix mMask, glbVector2 sSize )
		{
			this.ClearMask();
			this._bUseMask = true;
		}

		// }XN̏Iʒm܂B
		// [U}XNIݒvf`悵ɌĂ΂܂B
		public void ClearMask ()
		{
			if (this._bUseMask)
			{
				// ŏɃ}XN`悷͈͂̂yobt@NA
				trIOManager.Device.Clear(Dx3D.ClearFlags.ZBuffer, Color.Black, 1.0f, 0);
				this._bUseMask = false;
			}
		}

		#endregion


		// 
		public void Dispose()
		{
		}


		// Pt@C[hǗ쐬
		public siFile CreateLoader( seSceneManager inSceneManager, string strPath )
		{
			// t@C̑݃`FbN
			bool bExists = File.Exists( strPath );
			Debug.Assert( bExists );
			if ( !bExists ) return null;
			return new trFile( strPath );
		}


		public void DebugString(string strMsg)
		{
			Trace.Write( strMsg );
		}

	}
}
