﻿using System;
using System.Windows;
using System.Collections.Generic;
using System.Windows.Media;
using System.Windows.Media.Effects;
using System.Diagnostics;
using System.Reflection;

namespace evcIO
{
	// シェーダー管理
	// 
	public class effectManager
	{
		private static effectManager _manager = new effectManager();
		public static effectManager Instance { get { return effectManager._manager; } }

		private Dictionary<string,PixelShader> dicShader = new Dictionary<string,PixelShader>();

		// コンストラクタ
		private effectManager ()
		{

		}

		// シェーダー取得
		public PixelShader GetShader( string path )
		{
			PixelShader shader = null;
			if ( !this.dicShader.TryGetValue( path, out shader ) )
			{
				shader = new PixelShader();
				shader.UriSource = new Uri( path, UriKind.Relative );
				this.dicShader.Add( path, shader );
			}

			return shader;
		}
	
	}
}
