using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Shapes;
using evc;
using glb;
using sl;
using sl_evcPlayer;

namespace evcIO
{
	// J[XvCg`Ǘ
	public class trObjectColorSprite : siObjectColorSprite, IDisposable
	{
		private Rectangle drawObj;
		private effectBase _efColorNormal;
		private effectBase _efColorAdd;


		// RXgN^
		public trObjectColorSprite () 
		{
			this.drawObj = new Rectangle();
			this.drawObj.Fill = new SolidColorBrush();
			SolidColorBrush brush = (SolidColorBrush)this.drawObj.Fill;
			brush.Color = Colors.White;

			this._efColorNormal = new ColorNormalEffect();
			this._efColorAdd = new ColorAddEffect();
		}

		// TCYXVꂽ
		public void UpdateSize( glbVector2 sSize )
		{
			this.drawObj.Width = sSize.X;
			this.drawObj.Height = sSize.Y;
		}

		// `v
		public void Draw( int iElemID, IGLMatrix m, glbColor c )
		{
#if false
			siMaterial inMaterial = seRootScene.Instance.IOManager.Material;
			if (inMaterial.DoublyType == DoublyType.Mask)
			{
				trObjectDefine.ClearZBuffer(this.sSize, inMatrix, 1.0f);
			}
#endif
			siMaterial material = seRootScene.Instance.Material;
			effectBase ef = (material.BlendType == BlendType.ADD) ?
								this._efColorAdd : this._efColorNormal;

			if ( this.drawObj.Effect != ef )
			{
				this.drawObj.Effect = ef;
			}
			ef.BaseColor = Color.FromArgb(c.A, c.R, c.G, c.B); 
			slPutManager.Instance.Draw(this.drawObj, m);
		}

		// 
		public void Dispose()
		{
		}
	}
}
