using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Interop;
using System.Diagnostics;
using evc;
using glb;
using sl;


namespace evcIO
{
	// PǗ
	public class trObjectFontChar : siObjectFontChar
	{
		private glbVector2		sSize;

		private trObjectFont _parent;
		private TextBlock _drawObj;

		// TCY擾
		public glbVector2 Size	{ get { return this.sSize; } }

		// RXgN^
		internal trObjectFontChar ( trObjectFont parent, trObjectFontStyle style, char cInChar )
		{
			this._parent = parent;
			this._drawObj = new TextBlock();
			this._drawObj.Foreground = new SolidColorBrush();
			this._drawObj.Text = cInChar.ToString();
			this._drawObj.FontFamily = style.Family;
			// pointsNZ֕ϊ:SilverlightDPI96ŒƂ̂
			this._drawObj.FontSize = style.Height * 96 / 72;
			this._drawObj.FontWeight = style.Weight;
			this._drawObj.Foreground = new SolidColorBrush( Colors.White );

			// TCYZo
			this.sSize = new glbVector2( this._drawObj.ActualWidth,
										 this._drawObj.ActualHeight );
		}


		// @param mParent  : }gNX
		public void Draw( int iElemID, IGLMatrix m, glbColor sColor )
		{
			siMaterial material = seRootScene.Instance.Material;

			effectBase ef = (material.BlendType == BlendType.ADD) ?
									this._parent.AddEffect :
									this._parent.NormalEffect;

			if (this._drawObj.Effect != ef)
			{
				this._drawObj.Effect = ef;
			}
			ef.BaseColor = Color.FromArgb( sColor.A,sColor.R,sColor.G,sColor.B );
			slPutManager.Instance.Draw( this._drawObj, m );
		}
	}




	// Ǘ
	public class trObjectFont : siObjectFont
	{
		// tHgC[W쐬ǗNX
		private trObjectFontImageManager _fontManager;

		public effectBase NormalEffect { get; private set; }
		public effectBase AddEffect { get; private set; }


		// RXgN^
		public trObjectFont ()
		{
			this.NormalEffect = new TexNormalEffect();
			this.AddEffect = new FontAddEffect();	// tHgpFZ
			this._fontManager = new trObjectFontImageManager( this );
		}

		// tHgX^C쐬
		// @retval ID
		public int CreateFontStyle( string strFontName, float fHeight, seFontStyle Style )
		{
			return this._fontManager.CreateFontStyle( strFontName, fHeight, Style );
		}

		// o^JnEI錾
		public void BeginCharCreating(){}
		public void EndCharCreating(){}

		// o^
		public siObjectFontChar CreateChar( int iFontStyle, char cChar )
		{
			return new trObjectFontChar( this,
					this._fontManager.FindStyle( iFontStyle ), cChar );
		}


		// f[^Sč폜
		public void Clear()
		{
		}
		
		// 
		public void Dispose()
		{
			this.Clear();
			// eNX`f[^擾
			this._fontManager.Dispose();
			this._fontManager = null;
		}
	}

}
