using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Media;
using evc;
using sl;


namespace evcIO
{
	// tHgX^CǗ
	internal class trObjectFontStyle
	{
		public seFontStyle Style	{ get; private set; }
		public float Height			{ get; private set; }		// tHg̍擾Eݒ
		public string FontName		{ get; private set; }		// tHg̎擾Eݒ
		internal FontWeight Weight	{ get; private set; }		// ̑擾
		internal FontFamily Family	{ get; private set; }


		public bool IsSameData( trObjectFontStyle inStyle )
		{
			if ( this.Style != inStyle.Style ) return false;
			if ( this.Height != inStyle.Height ) return false;
			if ( !this.FontName.Equals( inStyle.FontName ) ) return false;

			return true;
		}

		// RXgN^
		public trObjectFontStyle ( string strFontName, float fHeight, seFontStyle eStyle )
		{
			this.FontName = strFontName;
			this.Height = fHeight;
			this.Style = eStyle;
			switch (eStyle)
			{
				case seFontStyle.Regular:
				case seFontStyle.Italic:
					this.Weight = FontWeights.Normal;
					break;
				case seFontStyle.Bold:
					this.Weight = FontWeights.Bold;
					break;
			}
			this.Family = new FontFamily( strFontName );
		}

		internal void Dispose()
		{
			if ( this.Family != null )
			{
//				this.Family.Dispose();
				this.Family = null;
			}
		}
		
	}

	// tHgX^CǗ
	internal class trObjectFontStyleManager
	{
		// tHgX^CXg
		List<trObjectFontStyle>	lisStyle = new List<trObjectFontStyle>();

		// X^C
		internal trObjectFontStyle Find( int iIndex )
		{
			int iCount = 0;
			foreach (trObjectFontStyle inStyleData in this.lisStyle)
			{
				if( iCount == iIndex ) return inStyleData;
				iCount ++;
			}

			return null;
		}

		// @retval ID
		public int Create( string strFontName, float fHeight, seFontStyle Style )
		{
			int iIndex = 0;

			trObjectFontStyle inFontStyle = new trObjectFontStyle(strFontName, fHeight, Style);
			foreach (trObjectFontStyle inStyleData in this.lisStyle)
			{
				if (inStyleData.IsSameData(inFontStyle))
				{
					inFontStyle.Dispose();
					return iIndex;
				}
				iIndex++;
			}
			this.lisStyle.Add( inFontStyle );
			return iIndex;
		}


		internal void Clear()
		{
			// tHgX^C̉
			this.lisStyle.ForEach( delegate( trObjectFontStyle inFontStyle )
			{
				inFontStyle.Dispose();
			});
			this.lisStyle.Clear();
		}

	}

}
