using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using evc;
using glb;
using sl;

namespace evcIO
{
	// eNX`XvCg`Ǘ
	public class trObjectMesh : siObjectMesh, IDisposable
	{
		private Stream	 _texture = null;	// eNX`
		private glbVector2I textureSize = glbVector2I.Zero;		// eNX`TCY
		private Mesh _mesh;
		private MeshIndex _indexType;


		public trObjectMesh (MeshIndex indexType, int iVertexCount, int iIndexCount )
		{
			this._indexType = indexType;
			// bV쐬
			this._mesh = new Mesh( iVertexCount, 10, 10 );

			// C[WɃbVǗ
			this._mesh.MeshImage.Tag = _mesh;
		}

		// eNX`XVꂽ
		void siObjectMesh.UpdateTexture(siResourceTexture texture )
		{
			if ( texture == null) 
			{
				this._texture = null;
				this.textureSize = glbVector2I.Zero;
				this._mesh.SetImage( null );
			}
			else
			{
				this._texture = ((trResourceTexture)texture).Texture;
				this.textureSize = texture.TextureSize;
				// C[Wo^
				BitmapImage bmp = new BitmapImage();
				bmp.SetSource( this._texture );
				this._mesh.SetImage( bmp );
				this._mesh.Resize( this.textureSize.X, this.textureSize.Y );
			}
		}


		// `v
		public void Draw(int iElemID, IGLMatrix m, glbColor sColor, IGLMatrix mUV)
		{
			if ( this._mesh == null ) return;

			this._mesh.Apply();

			// uv}gNXɂ͖ΉB


			siMaterial material = seRootScene.Instance.Material;
			this._mesh.SetEffect( (material.BlendType == BlendType.ADD) ?
									MeshEffectType.Add : MeshEffectType.Normal ); 

			this._mesh.Effect.BaseColor = Color.FromArgb( sColor.A, sColor.R, sColor.G, sColor.B );

			slPutManager.Instance.Draw( this._mesh.MeshImage, m );
		}

		// siObjectMeshVertex֌W
		// 

		public void SetPos(int iIndex, glbVector2 pos)
		{
			if ( this._mesh == null) return;
			PosInfo p = this._mesh.Vertex[ iIndex ];
			p.x = pos.X;
			p.y = pos.Y;
			// Nbv̍XV
			p.CheckClip( this._mesh.MeshSize );
		}

		public void SetUV(int iIndex, glbVector2 uv)
		{
			PosInfo p = this._mesh.Vertex[ iIndex ];
			p.tU = (int)(uv.X * 65535.0);
			p.tV = (int)(uv.Y * 65535.0);
		}

		public void BeginEditVertex( int iElemID ){}
		public void EndEditVertex(){}


		// siObjectMeshIndex֌W
		// 

		public void SetIndex(short[] id )
		{
			switch (this._indexType)
			{
				case MeshIndex.TriangleList:
					this._mesh.SetIndex( id );
					break;
				default:
					Debug.Assert( false );
					break;
			}
		}



		// 
		public void Dispose(){}
	}

}
