using System;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using evc;
using glb;
using sl;

namespace evcIO
{

	// eNX`XvCg`Ǘ
	public class trObjectTextureSprite : siObjectTextureSprite , IDisposable
	{
		private Point sUV = new Point(); // UV
		private Size sSize = new Size(); // TCY
		private glbVector2I sTextureSize = glbVector2I.Zero;		// eNX`TCY
		
		private const double SizeCorrection = 0.5;

		private Image _image;
		private Stream _texture;

		private effectBase _efNormal;	// ʏuh
		private effectBase _efAdd;		// FZ



		// RXgN^
		public trObjectTextureSprite ()
		{
			this._image = new Image();
			this._image.Source = new BitmapImage();
			this._image.Clip = new RectangleGeometry();
			this._efNormal = new TexNormalEffect();
			this._efAdd = new TexAddEffect();
			this._image.Effect = this._efNormal;
		}


		// eNX`XVꂽ
		public void UpdateTexture( siResourceTexture texResource )
		{
			BitmapImage bmp = (BitmapImage)this._image.Source;
			if ( texResource == null ) 
			{
				if ( this._texture != null )
				{
					this._texture.Dispose();
				}
				this._efAdd.Texture = null;
				this._efNormal.Texture = null;
			}
			else
			{
				this._texture = ((trResourceTexture)texResource).Texture; 
				bmp.SetSource( this._texture );
				this.sTextureSize.Set( texResource.TextureSize );
				this._image.Width = this.sTextureSize.X;
				this._image.Height = this.sTextureSize.Y;
				ImageBrush ib = new ImageBrush();
				ib.ImageSource = this._image.Source;
				
				this._efAdd.Texture = ib;
				this._efNormal.Texture = ib;
			}
		}

		// TCYXVꂽ
		public void UpdateSize( glbVector2 sNewSize )
		{
			this.sSize = new Size( sNewSize.X, sNewSize.Y );
		}
		// UVXVꂽ
		public void UpdateUV( glbVector2 sNewUV )
		{
			this.sUV = new Point( sNewUV.X, sNewUV.Y );
		}

		// _XV
		private void Update(){}


		// `v
		public void Draw( int iElemID, IGLMatrix m, glbColor c )
		{
			RectangleGeometry rg = (RectangleGeometry)this._image.Clip;
			rg.Rect = new Rect(0.0,0.0, this.sSize.Width, this.sSize.Height);

			this.DrawSub( iElemID, m, c );
		}

		// `v
		public void Draw( int iElemID, IGLMatrix mParent, glbColor c, IGLMatrix mUV )
		{
			Point sUVOffset = ((trMatrix)mUV).TransformCoordinate(this.sUV);
			sUVOffset.X *= this.sTextureSize.X;
			sUVOffset.Y *= this.sTextureSize.Y;

			seMatrixWork.Instance.UseMatrixWork( delegate(IUseWorkMatrix gw )
			{
				trMatrix m = (trMatrix)gw.GetMatrix();
				m.Identity();
				m.m31 = -sUVOffset.X;
				m.m32 = -sUVOffset.Y;
				mParent.Mul(m);
			});


			// 1.0ȏUVlJԂɂȂȂBvAl@
			RectangleGeometry rg = (RectangleGeometry)this._image.Clip;

			// vZ덷𖄂߂邽߂ɃTCY傫܂B
			// AAɂƂ΂₷Ȃ̂ŁAWƂăAt@
			// ȂقǕ␳Ă܂܂B
			double dAddSize = 0.18 * ((double)c.A / 255.0);
			Size sOutSize = new Size( this.sSize.Width + dAddSize, 
									  this.sSize.Height + dAddSize );
			rg.Rect = new Rect( sUVOffset, sOutSize );
			this.DrawSub( iElemID, mParent, c );
		}
		
		// `Tu[`
		private void DrawSub( int iElemID, IGLMatrix inMatrix, glbColor sColor )
		{
			// }XN`Ȃ牽ȂB
			siMaterial inMaterial = seRootScene.Instance.Material;
			trMaskControl inMaskControl = trMaskControl.Instance;

			// }eAʏ
			switch (inMaterial.DoublyType)
			{
				// ʏ`ȂɂȂɂȂB
				case DoublyType.Normal:
					this._image.OpacityMask = null;
					break;
				// }XN`Ȃ}XNƂēo^
				case DoublyType.Mask:
					inMaskControl.Add( iElemID, this._texture );
					inMaskControl.SetActive( iElemID, this, inMatrix );
					this._image.OpacityMask = null;
					// `揈͉ȂB
					return;
				// }XNQƕ`Ȃ}XNݒ
				case DoublyType.MaskReflection:
					inMaskControl.SetLocalMatrix( inMatrix );
					// }XNUVATCY𔽉fB
					// 
					this._image.OpacityMask = inMaskControl.ActiveBrush;
					break;
				default:
					break;
			}
			effectBase ef = (inMaterial.BlendType == BlendType.ADD) ? 
											this._efAdd : this._efNormal;
			if ( this._image.Effect != ef )
			{
				this._image.Effect = ef;
			}

			ef.BaseColor = Color.FromArgb( sColor.A, sColor.R, sColor.G, sColor.B );

			slPutManager.Instance.Draw( this._image, inMatrix ); 
		}


		// 
		public void Dispose()
		{
		}

	}
}
