using System;
using System.Diagnostics;
using System.IO;
using System.Windows;
using System.Windows.Resources;
using evc;
using sl;

namespace evcIO
{
	internal class trFile : siFile, ISlLoadUser
	{
		private Stream		inStream = null;
		private byte[]		abBuffer;
		private bool		bFinish;


		// V[zipňkꂽf[^f[^擾܂B
		//
		// V[t@C̏ꍇzipt@C[hB
		// @̒zipt@CƓprat@Cf[^ƂĂƂ肾B
		// ȊȌꍇseSceneManagerzipt@C擾A
		//   ̃t@Cf[^oB
		internal trFile ( seSceneManager inInSceneManager, string strPath )
		{
			this.bFinish = false;

			// V[t@CȂ
			if ( Path.GetExtension( strPath ) == ".pra" )
			{
				// zipt@C+".pra"Aj[Vt@CƂă[h
				SlLoadManager.Instance.Load( 
					Path.GetFileNameWithoutExtension(strPath) + ".zip", this );
			}
			// ȊȌꍇ̓V[+.zipt@C擾
			else
			{
				// V[}l[W(*.pra擾)
				string strPraName = Path.GetFileNameWithoutExtension( inInSceneManager.Name );
				this.LoadFromPack( strPraName + ".zip", strPath );
			}
		}

		// pbNt@Cf[^[h
		private void LoadFromPack( string strPackName, string strPath )
		{
			SlLoadInfo inLoadInfo = SlLoadManager.Instance.Find( strPackName );
			Debug.Assert( inLoadInfo.IsEnable );

			// pbNꂽt@Cf[^擾
			StreamResourceInfo inInfo = Application.GetResourceStream(
							inLoadInfo.Stream, new Uri(strPath, UriKind.Relative));

			this.inStream = inInfo.Stream;
			this.abBuffer = new byte[ this.inStream.Length ];
			this.inStream.BeginRead( this.abBuffer, 0, this.abBuffer.Length, this.AsyncCallback, null );
		}

		// [hR[obN
		private void AsyncCallback ( IAsyncResult ar )
		{
			// Xg[
			if ( inStream != null )
			{
				inStream.Close();
			}
			this.bFinish = true;
		}

		// t@C[hIۂ
		public bool IsLoadFinish		{ get { return this.bFinish; } }

		// [ht@Cf[^擾
		public byte[] Buffer
		{
			get 
			{
				if ( !this.bFinish ) return null;
				return this.abBuffer;
			}
		}

		// ԍXV
		public void Update(){}


		// [ḧ̉
		public void Dispose()
		{
			if ( this.inStream != null ) 
			{
				this.inStream.Close();
			}
			this.bFinish = false;
		}

		#region ISlLoadUser o

		// pbNt@C[h
		public void Completed(SlLoadInfo inLoadInfo)
		{
			string strPackName = inLoadInfo.Path;
			// pbNt@C+".pra"Aj[Vt@CƂă[h
			this.LoadFromPack( strPackName, 
				Path.GetFileNameWithoutExtension( strPackName ) + ".pra" );
		}

		#endregion
	}
}
